
Ruby - Bug #10432

wrong receiver of Binding from Method

10/27/2014 08:07 AM - nobu (Nobuyoshi Nakada)

Status: Closed   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version:    

ruby -v: trunk Backport: 2.0.0: DONE, 2.1: DONE

Description

Methodオブジェクトからto_proc.bindingで作られたBindingのreceiverが、Methodオブジェクトの元になったオブジェクトではなく、Methodオブジェクトになっています。

class C

  def foo;end

end

o = C.new

m = o.method(:foo)

p m.receiver                    # #<C:0x007fcada074e58>

p m.to_proc.binding.receiver    # #<Method: C#foo>

 2.0, 2.1ではBinding#receiverはありませんが、eval("self")で同様の結果になります。

Related issues:

Related to Ruby - Bug #10428: Segmentation fault when modifying local variabl... Closed 10/26/2014

Related to Ruby - Bug #11163: Binding from Method#to_proc.binding cause BUG Closed

Associated revisions

Revision e45b215fdd16f4fefc8f97f2391ef532f10c8f50 - 10/27/2014 08:17 AM - nobu (Nobuyoshi Nakada)

proc.c: fix method proc binding receiver

proc.c (method_proc): the receiver of binding from method should

be same as the receiver of the method.

[ruby-core:65917] [Bug #10432]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@48160 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e45b215f - 10/27/2014 08:17 AM - nobu (Nobuyoshi Nakada)

proc.c: fix method proc binding receiver

proc.c (method_proc): the receiver of binding from method should

be same as the receiver of the method.

[ruby-core:65917] [Bug #10432]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@48160 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 7149859bc35cfe7497a1e98118f22a1628e8703d - 11/28/2014 07:20 AM - U.Nakamura 

merge revision(s) 48160: [Backport #10432]

    * proc.c (method_proc): the receiver of binding from method should

      be same as the receiver of the method.

      [ruby-core:65917] [Bug #10432]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@48633 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 7149859b - 11/28/2014 07:20 AM - U.Nakamura 

merge revision(s) 48160: [Backport #10432]

    * proc.c (method_proc): the receiver of binding from method should

      be same as the receiver of the method.

      [ruby-core:65917] [Bug #10432]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@48633 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 997f821a58a7295436e64443ab4bd1d550cd6919 - 02/02/2015 01:54 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r48160: [Backport #10432]

    * proc.c (method_proc): the receiver of binding from method should

      be same as the receiver of the method.

      [ruby-core:65917] [Bug #10432]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@49472 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 997f821a - 02/02/2015 01:54 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r48160: [Backport #10432]

    * proc.c (method_proc): the receiver of binding from method should

      be same as the receiver of the method.

      [ruby-core:65917] [Bug #10432]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@49472 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 10/27/2014 08:17 AM - nobu (Nobuyoshi Nakada)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset r48160.

proc.c: fix method proc binding receiver

proc.c (method_proc): the receiver of binding from method should

be same as the receiver of the method.

[ruby-core:65917] [Bug #10432]

#2 - 11/12/2014 09:23 AM - nobu (Nobuyoshi Nakada)

- Related to Bug #10428: Segmentation fault when modifying local variables of binding obtained from the result of Method#to_proc added

#3 - 11/28/2014 07:22 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: REQUIRED, 2.1: REQUIRED to 2.0.0: DONE, 2.1: REQUIRED

Backported into ruby_2_0_0 at r48633.

(元のレポートにもあるように2.0.0にはBinding#receiverがないため、テストを一部変更)

#4 - 02/02/2015 01:55 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.0.0: DONE, 2.1: REQUIRED to 2.0.0: DONE, 2.1: DONE

Backported into ruby_2_1 at r49472.

#5 - 05/21/2015 03:04 AM - ko1 (Koichi Sasada)

Methodオブジェクトからto_proc.bindingで作られたBindingのreceiverが、Methodオブジェクトの元になったオブジェクトではなく、Methodオブジェクトになっています。

 元々、なんでこれじゃいけないんでしたっけ。

1.8 だと、b.eval('p self') がレシーバになっていたのかな。

#6 - 05/21/2015 01:30 PM - nagachika (Tomoyuki Chikanaga)

- Related to Bug #11163: Binding from Method#to_proc.binding cause BUG added
